/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const YesNoNode = require('../YesNoNode');
const UseAbility = require('../UseAbility');
const BattleCalc = require('../../BattleCalc');

const Q_faux_selves = function(actor, battleState, fullyBuffedCaseNode) {
  const node = new YesNoNode(actor, battleState);

  node.fauxSelfAbility = BattleCalc.getEquippedAbility(actor,'faux_self');

  node.branches[node.YES] = fullyBuffedCaseNode;

  if (node.fauxSelfAbility) {
    node.branches[node.NO] = new UseAbility(actor, 'faux_self', actor);
  } else {
    node.branches[node.NO] = node.branches[node.YES];
  }

  node.yesNoEvalFunction = function() {
    if (!node.fauxSelfAbility) {
      return true;
    }

    for (var i = 0; i < this.battleState.allUnits.length; ++i) {
      var unit = this.battleState.allUnits[ i ];
      if (unit.faux_self && unit.ownerId===this.actor.uid && unit.inPlay && !unit.dead) {
        return true;
      }
    }

    return false;
  };

  return node;
};
module.exports = Q_faux_selves;
