/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */	
const YesNoNode = require( '../YesNoNode' );
const TreeNode = require( '../TreeNode' );
const Q_any_nearby_allies = require( './Q_any_nearby_allies' );

const Q_any_enemies = function( actor, battleState, moveTowardsTree ) {
	const node = new YesNoNode( actor, battleState );
	
	node.branches[node.YES] = new Q_any_nearby_allies( actor, battleState, moveTowardsTree );
	node.branches[node.NO] = new TreeNode();
	
	node.yesNoEvalFunction = function() {
		return this.battleState.getEnemiesOfUnit( this.actor ).length > 0;
	}		
	
	return node;
}
module.exports = Q_any_enemies
