const HexTile = require('./HexTile')
const DoorsFactory = require('./DoorsFactory')
const WallsFactory = require('./WallsFactory')

const EastWestHallway = function( entrance ) {
  const tiles = []
  var x, y
  const columns = 15 + Math.round(Math.random() * 12)
  const rows = 4 + Math.round(Math.random() * 4)

  for( x = 0; x < columns; x += 2 ) { 
    for( y = 1; y < rows; y += 2 ) {
      tiles.push( HexTile(x,y) );
    }
  }
  
  for( x = 1; x < columns; x += 2 ) {
    for( y = 0; y < rows; y += 2 ) {
      tiles.push( HexTile(x,y) );
    }
  }

  var exits
  if (entrance === 'EAST') {
    exits = ['WEST']
  } else if(entrance === 'WEST') {
    exits = ['EAST']
  } else {
    throw new Error('Invalid entrance argument in EastWestHallway')
  }

  var doors = DoorsFactory(tiles, entrance, exits)
  var walls = WallsFactory(tiles, doors)

  return {
    tiles,
    doors,
    walls
  }
}
module.exports = EastWestHallway
