const WallsFactory = function( tiles, doors ) {

	const makeWall = ( x, y ) => {
		return {
			wall: true,
			x,
			y
		};
	};

	var walls = [];
	var tile, obj;
	var i, j, k;
	var anythingNE, anythingNW, anythingSE, anythingSW;

	const test = ( tile, testFunc ) => {
		for( j = 0; j < tiles.length; ++j ) {
			if( testFunc(tile,tiles[j]) ) {
				return true;
			}
		}

		for( k = 0; k < doors.length; ++k ) {
			if( testFunc(tile,doors[k]) ) {
				return true;
			}
		}

		return false;
	};

	for( i = 0; i < tiles.length; ++i ) {
		tile = tiles[i];

		anythingNE = test( tile, (tile,obj)=>{ return obj.x===tile.x+1 && obj.y===tile.y-1 ; } );
		if( !anythingNE ) {
			walls.push( makeWall( tile.x+1, tile.y-1) );
		}

		anythingNW = test( tile, (tile,obj)=>{ return obj.x===tile.x-1 && obj.y===tile.y-1; } );
		if( !anythingNW ) {
			walls.push( makeWall( tile.x-1, tile.y-1) );
		}

		anythingSE = test( tile, (tile,obj)=>{ return obj.x===tile.x+1 && obj.y===tile.y+1; } );
		if( !anythingSE ) {
			walls.push( makeWall( tile.x+1, tile.y+1) );
		}

		anythingSW = test( tile, (tile,obj)=>{ return obj.x===tile.x-1 && obj.y===tile.y+1; } );
		if( !anythingSW ) {
			walls.push( makeWall( tile.x-1, tile.y+1) );
		}		
	}

	return walls;
};
module.exports = WallsFactory;